/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI AUDEC configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_audec.h"
#include "firmware/firmware_audio.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_audec_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_AUDEC_FuncStrT audec_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_AUDEC_Init(void)
{
    int32_t ret = 0;

    audec_funcStr.GetCapabilities = FAPI_AUDEC_GetCapabilities;
    audec_funcStr.Init            = FAPI_AUDEC_Init;
    audec_funcStr.Exit            = FAPI_AUDEC_Exit;
    audec_funcStr.Open            = FAPI_AUDEC_Open;
    audec_funcStr.Close           = FAPI_AUDEC_Close;
    audec_funcStr.Start           = FAPI_AUDEC_Start;
    audec_funcStr.Stop            = FAPI_AUDEC_Stop;
    audec_funcStr.GetStatus       = FAPI_AUDEC_GetStatus;
    audec_funcStr.SetCodecParams  = FAPI_AUDEC_SetCodecParams;
    audec_funcStr.PtsNotifier     = FAPI_AUDEC_PtsNotifier;
    audec_funcStr.Reboot          = FAPI_AUDEC_Reboot;
    audec_funcStr.Suspend         = FAPI_AUDEC_Suspend;
    audec_funcStr.Resume          = FAPI_AUDEC_Resume;
    audec_funcStr.OpenMixer       = FAPI_AUDEC_OpenMixer;
    audec_funcStr.InvalidatePts   = FAPI_AUDEC_InvalidatePts;
    audec_funcStr.SetOutputDelay  = FAPI_AUDEC_SetOutputDelay;
    audec_funcStr.firmware_type   = FIRMWARE_audio_embedded;

    /* setup interrupt */
    /* audec */

    /* initialize function of FAPI CDL (audec) */
    ret = audec_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_AUDEC_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    audec_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(audec_funcStr);

EXPORT_SYMBOL(FAPEXCFG_AUDEC_Init);
EXPORT_SYMBOL(FAPEXCFG_AUDEC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
