/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Microelectronics Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 *  Copyright (C) 2008-2010 Fujitsu Microelectronics Limited, All Rights Reserved.
 */
/*
 FAPI FLASH configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_blte.h"
#include "fapi/drv_intr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_blte_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_BLTE_FuncStrT blte_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
FAPICORE_ISRRET_T FAPEXCFG_BLTE_Isr(int arg1, void *ptr)
{
    uint32_t result;

    /* Interrupt service routine for Isr */
    result = blte_funcStr.Isr();

    FAPICORE_ISRRETVAL(result)
}

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_BLTE_Init(void)
{
    int32_t ret;
    
    blte_funcStr.Init                = FAPI_BLTE_Init;
    blte_funcStr.Exit                = FAPI_BLTE_Exit;
    blte_funcStr.Isr                 = FAPI_BLTE_Isr;
    blte_funcStr.Bsr                 = FAPI_BLTE_Bsr;
    blte_funcStr.Open                = FAPI_BLTE_Open;
    blte_funcStr.SetFrameBase        = FAPI_BLTE_SetFrameBase;
    blte_funcStr.Close               = FAPI_BLTE_Close;
    blte_funcStr.SetColourKeying      = FAPI_BLTE_SetColourKeying;
    blte_funcStr.SetShadingParams    = FAPI_BLTE_SetShadingParams;
    blte_funcStr.SetBlendingParams   = FAPI_BLTE_SetBlendingParams;
    blte_funcStr.SetInputColorMatrix = FAPI_BLTE_SetInputColourMatrix;
    blte_funcStr.SetOutputColourMatrix = FAPI_BLTE_SetOutputColourMatrix;
    blte_funcStr.SetClut             = FAPI_BLTE_SetClut;
    blte_funcStr.SetClip             = FAPI_BLTE_SetClip;
    blte_funcStr.SetSourceLayout     = FAPI_BLTE_SetSourceLayout;
    blte_funcStr.DrawRect            = FAPI_BLTE_DrawRect;
    blte_funcStr.DrawFont            = FAPI_BLTE_DrawFont;
    blte_funcStr.DrawULine           = FAPI_BLTE_DrawULine;
    blte_funcStr.Copy                = FAPI_BLTE_Copy;
    blte_funcStr.DrawBitmap          = FAPI_BLTE_DrawBitmap;
    blte_funcStr.SetProcessingMode      = FAPI_BLTE_SetProcessingMode;
    blte_funcStr.Begin               = FAPI_BLTE_Begin;
    blte_funcStr.End                 = FAPI_BLTE_End;


    /* setup interrupt */
    FAPEXCFG_INTR_RegisterISR( FAPI_INTR_BLTE, FAPEXCFG_BLTE_Isr, NULL,
                               SA_INTERRUPT, (uint8_t*)"BLTE", 0, 0 );
 
    /* initialize function of FAPI CDL (flash) */
    ret = blte_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_BLTE_Cleanup(void)
{
    blte_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(blte_funcStr);

EXPORT_SYMBOL(FAPEXCFG_BLTE_Init);
EXPORT_SYMBOL(FAPEXCFG_BLTE_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
