/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 BOARDS configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapex_config_cmn.h"
#include "fapex_cfdlsaf.h"
#include "fapex_boards_func.h"
#include "fapex_func_ext.h"

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FME_DEVKIT
#include "boards/mb86h61_dk01.h"
#endif

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FMC_DEVKIT
#include "boards/mb86h61_pdkv1.h"
#endif
/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_BOARDS_FuncStrT boards_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_BOARDS_Init(void)
{
    int32_t ret;

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FME_DEVKIT
    boards_funcStr.BoardIfc_Register       = BOARD_FME_H61DK01_BoardIfc_Register;
//    boards_funcStr.BoardIfc_SetAddInitHook = BOARD_FME_MB86H61_DK01_BoardIfc_SetAddInitHook;
    boards_funcStr.RegisterFrontends       = BOARD_FME_H61DK01_RegisterFrontends;
#endif

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FMC_DEVKIT
    boards_funcStr.BoardIfc_Register       = BOARD_FMC_H61PDKV1_BoardIfc_Register;
//    boards_funcStr.BoardIfc_SetAddInitHook = BOARD_FME_MB86H61_DK01_BoardIfc_SetAddInitHook;
    boards_funcStr.RegisterFrontends       = BOARD_FMC_H61PDKV1_RegisterFrontends;
#endif

    /* register the required function for boards_funcStr.BoardIfc_Register() */
    gpio_funcStr.SetPinFunction = FAPI_GPIO_SetPinFunction;

    /* initialize function of FAPI CDL (boards) */
    ret = boards_funcStr.BoardIfc_Register(BOARDS_REGISTER_DEFAULT, 0);

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_BOARDS_Cleanup(void)
{
    
}
/* nothing */

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(boards_funcStr);
EXPORT_SYMBOL(FAPEXCFG_BOARDS_Init);
EXPORT_SYMBOL(FAPEXCFG_BOARDS_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
