/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI BOOT configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_boot.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_cfdlsaf.h"
#include "fapex_boot_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_BOOT_FuncStrT boot_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_BOOT_Init(void)
{
    int32_t ret;

    boot_funcStr.Init                  = FAPI_BOOT_Init;
    boot_funcStr.Exit                  = FAPI_BOOT_Exit;
    boot_funcStr.Open                  = FAPI_BOOT_Open;
    boot_funcStr.Close                 = FAPI_BOOT_Close;
    boot_funcStr.GetInfo               = FAPI_BOOT_GetInfo;
    boot_funcStr.GetBootMode           = FAPI_BOOT_GetBootMode;
    boot_funcStr.GetBootDevice         = FAPI_BOOT_GetBootDevice;
    boot_funcStr.LoadImageByVersion    = FAPI_BOOT_LoadImageByVersion;
    boot_funcStr.GetImageInfoByVersion = FAPI_BOOT_GetImageInfoByVersion;

    /* initialize function of FAPI CDL (boot) */
    ret = boot_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_BOOT_Cleanup(void)
{
    boot_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(boot_funcStr);

EXPORT_SYMBOL(FAPEXCFG_BOOT_Init);
EXPORT_SYMBOL(FAPEXCFG_BOOT_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
