/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI CLKPWR configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_clkpwr.h"
#include "fapi/reg_clkpwr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_clkpwr_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_CLKPWR_FuncStrT clkpwr_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_CLKPWR_Init(void)
{
    int32_t ret = 0;

    clkpwr_funcStr.Init                = FAPI_CLKPWR_Init;
    clkpwr_funcStr.Exit                = FAPI_CLKPWR_Exit;
    clkpwr_funcStr.Open                = FAPI_CLKPWR_Open;
    clkpwr_funcStr.Close               = FAPI_CLKPWR_Close;
    clkpwr_funcStr.GetPwm              = FAPI_CLKPWR_GetPwm;
    clkpwr_funcStr.GetState            = FAPI_CLKPWR_GetState;
    clkpwr_funcStr.Reset               = FAPI_CLKPWR_Reset;
    clkpwr_funcStr.ResetAudioProcessor = FAPI_CLKPWR_ResetAudioProcessor;
    clkpwr_funcStr.ResetTsdBlock       = FAPI_CLKPWR_ResetTsdBlock;
    clkpwr_funcStr.ResetWatchdog       = FAPI_CLKPWR_ResetWatchdog;
    clkpwr_funcStr.SetPwm              = FAPI_CLKPWR_SetPwm;
    clkpwr_funcStr.PowerDown           = FAPI_CLKPWR_PowerDown;
    clkpwr_funcStr.StartWatchdog       = FAPI_CLKPWR_StartWatchdog;
    clkpwr_funcStr.StopWatchdog        = FAPI_CLKPWR_StopWatchdog;
    clkpwr_funcStr.PowerUp             = FAPI_CLKPWR_PowerUp;
    clkpwr_funcStr.SetPptMode          = FAPI_CLKPWR_SetPptMode;
    clkpwr_funcStr.SetPllFreq          = FAPI_CLKPWR_SetPllFreq;
    clkpwr_funcStr.SetDeepPowerDown    = FAPI_CLKPWR_SetDeepPowerDown;
    clkpwr_funcStr.GetWakeupSrc        = FAPI_CLKPWR_GetWakeupSrc;

    /* initialize function of FAPI RAL */
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_CLKPWR] == 0){
        FREG_CLKPWR_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_CLKPWR] = 1;
    }

    /* setup interrupt */
    /* clkpwr */

    /* initialize function of FAPI CDL (clkpwr) */
    ret = clkpwr_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_CLKPWR_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    clkpwr_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(clkpwr_funcStr);

EXPORT_SYMBOL(FAPEXCFG_CLKPWR_Init);
EXPORT_SYMBOL(FAPEXCFG_CLKPWR_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
