/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI configuration header file (common)
*/
#ifndef _FAPEX_CONFIG_CMN_H
#define _FAPEX_CONFIG_CMN_H

#include "fapex_types.h"
#include "fapex_stdhdr.h"
#include "fapi/drv_auout.h"

#ifdef __LINUX__
#include "fapi/reg4linux.h"
#else
#define FIO_ADDRESS(block,address) (address)
#endif

/* prototype */
int32_t FAPEXCFG_INTR_RegisterISR(int32_t irqNo,
                                  FAPICORE_ISRRET_T (*pIsr)(int, void*),
                                  FAPICORE_BSRRET_T (*pBsr)(unsigned long),
                                  uint32_t flags, uint8_t *devname,
                                  uint32_t bsrStackSize,
                                  uint32_t bsrFifoDepth);
int32_t FAPEXCFG_INTR_UnregisterISR(int32_t irqNo);
void   *FAPEXCFG_INTR_IsBsrFunction(int32_t irqNo);
int32_t FAPEXCFG_INTR_RegisterBSR(void *ptr);

#ifndef __LINUX__
int32_t FAPEXCFG_INTR_InitDrivers(void);
#endif

int32_t FAPEXCFG_BOARDS_Init(void);
void    FAPEXCFG_BOARDS_Cleanup(void);

int32_t FAPEXCFG_AUDEC_Init(void);
void    FAPEXCFG_AUDEC_Cleanup(void);

int32_t FAPEXCFG_AUOUT_Init(void);
void    FAPEXCFG_AUOUT_Cleanup(void);
FAPI_AUOUT_StreamInfoT FAPEXCFG_AUOUT_GetStreamInfo(FAPI_SYS_HandleT handle);

int32_t FAPEXCFG_BM_Init(void);
void    FAPEXCFG_BM_Cleanup(void);


int32_t FAPEXCFG_BOOT_Init(void);
void    FAPEXCFG_BOOT_Cleanup(void);

int32_t FAPEXCFG_CLKPWR_Init(void);
void    FAPEXCFG_CLKPWR_Cleanup(void);

int32_t FAPEXCFG_DESC_Init(void);
void    FAPEXCFG_DESC_Cleanup(void);

int32_t FAPEXCFG_DMA_Init(void);
void    FAPEXCFG_DMA_Cleanup(void);

//int32_t FAPEXCFG_ETH_Init(void);
//void    FAPEXCFG_ETH_Cleanup(void);

int32_t FAPEXCFG_FLASH_Init(void);
void    FAPEXCFG_FLASH_Cleanup(void);

int32_t FAPEXCFG_FPC_Init(void);
void    FAPEXCFG_FPC_Cleanup(void);

int32_t FAPEXCFG_GPIO_Init(void);
void    FAPEXCFG_GPIO_Cleanup(void);

int32_t FAPEXCFG_GPREG_Init(void);
void    FAPEXCFG_GPREG_Cleanup(void);

int32_t FAPEXCFG_HDMI_Init(void);
void    FAPEXCFG_HDMI_Cleanup(void);

int32_t FAPEXCFG_HDMICEC_Init(void);
void    FAPEXCFG_HDMICEC_Cleanup(void);

int32_t FAPEXCFG_I2C_Init(void);
void    FAPEXCFG_I2C_Cleanup(void);

int32_t FAPEXCFG_ICC_Init(void);
void    FAPEXCFG_ICC_Cleanup(void);

int32_t FAPEXCFG_INTR_Init(void);
void    FAPEXCFG_INTR_Cleanup(void);

int32_t FAPEXCFG_IR_Init(void);
void    FAPEXCFG_IR_Cleanup(void);

int32_t FAPEXCFG_MMU_Init(void);
void    FAPEXCFG_MMU_Cleanup(void);

int32_t FAPEXCFG_SSP_Init(void);
void    FAPEXCFG_SSP_Cleanup(void);

int32_t FAPEXCFG_SYNC_Init(void);
void    FAPEXCFG_SYNC_Cleanup(void);

int32_t FAPEXCFG_TIMER_Init(void);
void    FAPEXCFG_TIMER_Cleanup(void);

int32_t FAPEXCFG_TSD_Init(void);
void    FAPEXCFG_TSD_Cleanup(void);

int32_t FAPEXCFG_TTX_Init(void);
void    FAPEXCFG_TTX_Cleanup(void);

int32_t FAPEXCFG_UART_Init(void);
void    FAPEXCFG_UART_Cleanup(void);

int32_t FAPEXCFG_UPI_Init(void);
void    FAPEXCFG_UPI_Cleanup(void);

//int32_t FAPEXCFG_USB_Init(void);
//void    FAPEXCFG_USB_Init(void);

int32_t FAPEXCFG_VIDEC_Init(void);
void    FAPEXCFG_VIDEC_Cleanup(void);

int32_t FAPEXCFG_VIENC_Init(void);
void    FAPEXCFG_VIENC_Cleanup(void);

int32_t FAPEXCFG_VISCALE_Init(void);
void    FAPEXCFG_VISCALE_Cleanup(void);

int32_t FAPEXCFG_FAPI_Init(void);
void    FAPEXCFG_FAPI_Cleanup(void);

int32_t FAPEXCFG_BOARD_Init(void);
void    FAPEXCFG_BOARD_cleanup(void);

int32_t FAPEXCFG_BLTE_Init(void);
void    FAPEXCFG_BLTE_Cleanup(void);

int32_t FAPEXCFG_ADC_Init(void);
void    FAPEXCFG_ADC_Cleanup(void);

int32_t FAPEXCFG_PV_Init(void);
void    FAPEXCFG_PV_Cleanup(void);

#endif /* _FAPEX_CONFIG_CMN_H */
