/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI HDMI configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_hdmi_cec.h"
#include "fapi/drv_timer.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_hdmicec_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_HDMICEC_FuncStrT hdmicec_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_HDMICEC_Init(void)
{
    int32_t ret;

    hdmicec_funcStr.Init                    = FAPI_HDMI_CEC_Init;
    hdmicec_funcStr.Exit                    = FAPI_HDMI_CEC_Exit;
    hdmicec_funcStr.Open                    = FAPI_HDMI_CEC_Open;
    hdmicec_funcStr.Close                   = FAPI_HDMI_CEC_Close;
    hdmicec_funcStr.SetCecConfigParameters  = FAPI_HDMI_SetCecConfigParameters;
    hdmicec_funcStr.SetCecMessageParameters = FAPI_HDMI_SetCecMessageParameters;
    hdmicec_funcStr.GetCecMessageParameters = FAPI_HDMI_GetCecMessageParameters;
    hdmicec_funcStr.SendCecMessage          = FAPI_HDMI_SendCecMessage;
    hdmicec_funcStr.ReceivingCecMessage     = FAPI_HDMI_ReceivingCecMessage;
    hdmicec_funcStr.CheckCecSendStatus      = FAPI_HDMI_CheckCecSendStatus;
    hdmicec_funcStr.CheckCecReceiveStatus   = FAPI_HDMI_CheckCecReceiveStatus;
    hdmicec_funcStr.SetCecLogicalAddress    = FAPI_HDMI_SetCecLogicalAddress;
    hdmicec_funcStr.GetCecLogicalAddress    = FAPI_HDMI_GetCecLogicalAddress;

    /* initialize function of FAPI CDL (hdmi_cec) */
    ret = hdmicec_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_HDMICEC_Cleanup(void)
{
    hdmicec_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(hdmicec_funcStr);

EXPORT_SYMBOL(FAPEXCFG_HDMICEC_Init);
EXPORT_SYMBOL(FAPEXCFG_HDMICEC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
