/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI MMU configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_mmu.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_mmu_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_MMU_FuncStrT mmu_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_MMU_Init(void)
{
    int32_t ret = 0;

    mmu_funcStr.SetSegmentSizeMBytes    = FAPI_MMU_SetSegmentSizeMBytes;
    mmu_funcStr.SetSegmentStragegyMode  = FAPI_MMU_SetSegmentStragegyMode;
    mmu_funcStr.SetSegmentFunctionMode  = FAPI_MMU_SetSegmentFunctionMode;
    mmu_funcStr.SetSegmentAlignmentBits = FAPI_MMU_SetSegmentAlignmentBits;
    mmu_funcStr.Init                    = FAPI_MMU_Init;
    mmu_funcStr.Exit                    = FAPI_MMU_Exit;
    mmu_funcStr.SetTlb1BaseAddr         = FAPI_MMU_SetTlb1BaseAddr;
    mmu_funcStr.SetTlb2BaseAddr         = FAPI_MMU_SetTlb2BaseAddr;
    mmu_funcStr.Open                    = FAPI_MMU_Open;
    mmu_funcStr.Close                   = FAPI_MMU_Close;
    mmu_funcStr.GetPhysAddr             = FAPI_MMU_GetPhysAddr;
    mmu_funcStr.GetVirtAddr             = FAPI_MMU_GetVirtAddr;
    mmu_funcStr.ChangeMapEntry          = FAPI_MMU_ChangeMapEntry;
    mmu_funcStr.CreateSegment           = FAPI_MMU_CreateSegment;
    mmu_funcStr.ReleaseSegment          = FAPI_MMU_ReleaseSegment;
    mmu_funcStr.ResetSegment            = FAPI_MMU_ResetSegment;
    mmu_funcStr.GetSegment              = FAPI_MMU_GetSegment;
    mmu_funcStr.GetSegmentInfo          = FAPI_MMU_GetSegmentInfo;
    
    mmu_funcStr.Malloc                  = FAPI_MMU_Malloc;
    mmu_funcStr.Zalloc                  = FAPI_MMU_Zalloc;
    mmu_funcStr.Realloc                 = FAPI_MMU_Realloc;
    mmu_funcStr.Free                    = FAPI_MMU_Free;
    mmu_funcStr.ReportMemory            = FAPI_MMU_ReportMemory;

#if 0 /* org */
    mmu_funcStr.SetSegmentSizeMBytes(FAPI_MMU_HEAP_SEGMENT_INDEX_SYS0,12);
    mmu_funcStr.SetSegmentSizeMBytes(FAPI_MMU_HEAP_SEGMENT_INDEX_SYS1,13);
#else
    mmu_funcStr.SetSegmentSizeMBytes(FAPI_MMU_HEAP_SEGMENT_INDEX_SYS0,12);
    mmu_funcStr.SetSegmentSizeMBytes(FAPI_MMU_HEAP_SEGMENT_INDEX_SYS1,5);
#endif

    /* initialize function of FAPI CDL (mmu) */
    ret = mmu_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_MMU_Cleanup(void)
{
    mmu_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(mmu_funcStr);

EXPORT_SYMBOL(FAPEXCFG_MMU_Init);
EXPORT_SYMBOL(FAPEXCFG_MMU_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
