/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI PV configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_pv.h"
#include "fapi/drv_pv_ca.h"
#include "fapi/drv_intr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_pv_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_PV_FuncStrT pv_funcStr;

/*--------------------------------------------------------*/
/* Local Data                                             */
/*--------------------------------------------------------*/

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_PV_Init(void)
{
    int32_t ret = 0;

    pv_funcStr.Init = FAPI_PV_Init;
    pv_funcStr.Exit = FAPI_PV_Exit;
    pv_funcStr.Open = FAPI_PV_Open;
    pv_funcStr.Close = FAPI_PV_Close;
    pv_funcStr.ReadData = FAPI_PV_ReadData;
    pv_funcStr.WriteData = FAPI_PV_WriteData;
    pv_funcStr.GetBurnCounts = FAPI_PV_GetBurnCounts;
    pv_funcStr.ResetBurnCounts = FAPI_PV_ResetBurnCounts;
    pv_funcStr.ReadSipromData = FAPI_PV_ReadSipromData;
    pv_funcStr.ReadSipromBoot= FAPI_PV_ReadSipromBoot;
    pv_funcStr.WriteSipromData = FAPI_PV_WriteSipromData;
    pv_funcStr.WriteSipromBoot = FAPI_PV_WriteSipromBoot;
    pv_funcStr.ReadBitfield = FAPI_PV_ReadBitfield;
    pv_funcStr.WriteBitfield = FAPI_PV_WriteBitfield;
    pv_funcStr.GetBitfieldByName = FAPI_PV_GetBitfieldByName;
   
    /* initialize function of FAPI CDL (adc) */
    ret = pv_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_PV_Cleanup(void)
{
    pv_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(pv_funcStr);

EXPORT_SYMBOL(FAPEXCFG_PV_Init);
EXPORT_SYMBOL(FAPEXCFG_PV_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */

