/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI UPI configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_upi.h"
#include "fapi/drv_intr.h"
#include "fapi/reg_upi.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_upi_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_UPI_FuncStrT upi_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_UPI_Init(void)
{
    int32_t ret = 0;

    upi_funcStr.Init             = FAPI_UPI_Init;
    upi_funcStr.Exit             = FAPI_UPI_Exit;
    upi_funcStr.Open             = FAPI_UPI_Open;
    upi_funcStr.Close            = FAPI_UPI_Close;
    upi_funcStr.SetDefaults      = FAPI_UPI_SetDefaults;
    upi_funcStr.SetConfiguration = FAPI_UPI_SetConfiguration;
    upi_funcStr.GetConfiguration = FAPI_UPI_GetConfiguration;
    upi_funcStr.SetWaitTimer     = FAPI_UPI_SetWaitTimer;
    upi_funcStr.GetWaitTimer     = FAPI_UPI_GetWaitTimer;
    upi_funcStr.GetBaseAddress   = FAPI_UPI_GetBaseAddress;
    upi_funcStr.Lock             = FAPI_UPI_Lock;
    upi_funcStr.Unlock           = FAPI_UPI_Unlock;

    /* initialize function of FAPI RAL */
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_UPI] == 0){
        FREG_UPI_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_UPI] = 1;
    }

    /* initialize function of FAPI CDL (upi) */
    ret = upi_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_UPI_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    upi_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(upi_funcStr);

EXPORT_SYMBOL(FAPEXCFG_UPI_Init);
EXPORT_SYMBOL(FAPEXCFG_UPI_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
