/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI VIENC configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_vienc.h"
#include "fapi/drv_intr.h"
#include "fapi/reg_ve.h"
#include "fapi/reg_ve_hd.h"
#include "fapi/reg_vo.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_vienc_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_VIENC_FuncStrT vienc_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_VIENC_Init(void)
{
    int32_t ret = 0;

    vienc_funcStr.Init                  = FAPI_VIENC_Init;
    vienc_funcStr.Exit                  = FAPI_VIENC_Exit;
    vienc_funcStr.InitClocks            = FAPI_VIENC_InitClocks;
    vienc_funcStr.Open                  = FAPI_VIENC_Open;
    vienc_funcStr.Close                 = FAPI_VIENC_Close;
    vienc_funcStr.Start                 = FAPI_VIENC_Start;
    vienc_funcStr.Stop                  = FAPI_VIENC_Stop;
    vienc_funcStr.GetSystemType         = FAPI_VIENC_GetSystemType;
    vienc_funcStr.EnableDisableWss      = FAPI_VIENC_EnableDisableWss;
    vienc_funcStr.SetWssData            = FAPI_VIENC_SetWssData;
    vienc_funcStr.GetWssData            = FAPI_VIENC_GetWssData;
    vienc_funcStr.SetColourComponent    = FAPI_VIENC_SetColourComponent;
    vienc_funcStr.GetColourComponent    = FAPI_VIENC_GetColourComponent;
    vienc_funcStr.SetDacAssignment      = FAPI_VIENC_SetDacAssignment;
//    vienc_funcStr.ChangeColourComponent = FAPI_VIENC_ChangeColourComponent;

    /* initialize function of FAPI RAL */
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VO] == 0){
        FREG_VO_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VO] = 1;
    }
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VE] == 0){
        FREG_VE_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VE] = 1;
    }
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VE_HD] == 0){
        FREG_VE_HD_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_VE_HD] = 1;
    }

    /* initialize function of FAPI CDL (vienc) */
    ret = vienc_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_VIENC_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    vienc_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(vienc_funcStr);

EXPORT_SYMBOL(FAPEXCFG_VIENC_Init);
EXPORT_SYMBOL(FAPEXCFG_VIENC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
