/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL Audio Output header file (private)
*/

#ifndef _FAPEX_FDLAUOUT_PRIV_H
#define _FAPEX_FDLAUOUT_PRIV_H

#include "fapex/abst_libauout.h"
#include "fapi/drv_auout_apt_vol.h"
#include "fapi/drv_auout_apt_ssrc.h"

/*!
*************************************************************************
** \brief FDL Auout context structure
*************************************************************************/
typedef struct {
    int32_t  id;            //!< id
    int32_t  used_count;    //!< used count
#ifdef __LINUX__
    struct kref kref;           //!< kref struct
    int32_t     close_result;   //!< return code at closing
#endif

    void *pCfdlHdl;         //!< The pointer to the CFDL context
    int32_t  status;        //!< AUOUT status

    void *pFAPICtxHdl;      //!< FAPI driver's context

    uint32_t enable_flag;   //!< Audio Output Type enable flag (see #FAPEX_AUOUT_ENABLE_xxx)
    uint32_t channel_flag;  //!< Audio Output Channel enable flag (see #FAPEX_AUOUT_CHANNEL_xxx)
    uint32_t dualmono_flag; //!< Dual Mono enable flag

    uint32_t                 enable_sinfo;   //!< enable flag for calling FAPI_AUOUT_SetStreamInfo()
    FAPEX_AUOUT_PcmInfoStrT  pcm_info;
    int32_t                  stream_type;
    uint8_t                  hdmi_ifcMask;  //Bitmask of the audio output interface which should be transmited via HDMI.
                                            //This is one of:
                                            //#FAPI_AUOUT_I2S_MASK to indicate I2S should be trasnmited.
                                            //#FAPI_AUOUT_SPDIF_MASK to indicate SPDIF should be transmited.
    void *pAudioAptVolHandle;       //!< FAPI driver  audio Apt Volume control  context
    void *pAudioApt11dbHandle;      //!< FAPI driver  audio Apt  context
    void *pAudioAptSsrcHandle;      //!< FAPI driver  audio Apt  context
    FAPI_AUOUT_AptVolParamsT   *audioAptVolParamsPtr;
    FAPI_AUOUT_AptSsrcParamsT  *audioAptSsrcParamsPtr;

                                            ;
    void *pcmBmHdl; //! <pcm output BM handler
} FAPEXFDL_AUOUT_StrT;

/*! \brief AUOUT enable flag */
#define FAPEXFDL_AUOUT_SET_PCMINFO      (0x0001)
#define FAPEXFDL_AUOUT_SET_STREAMTYPE   (0x0002)

#endif /* !_FAPEX_FDLAUOUT_PRIV_H */
