/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL FPC header file (private)
*/

#ifndef _FAPEX_FDLFPC_PRIV_H
#define _FAPEX_FDLFPC_PRIV_H

/*!
*************************************************************************
** \brief FDL FPC context structure
*************************************************************************/
typedef struct {
    int32_t id;             //!< id
    int32_t used_count;     //!< used count
#ifdef __LINUX__
    struct kref kref;           //!< kref struct
    int32_t     close_result;   //!< return code at closing
#endif

    void    *pCfdlHdl;      //!< The pointer to the CFDL context
    void    *pFAPICtxHdl;   //!< FAPI driver's context

    FAPEXCFDLSAF_EventStrT  btn_event;     //!< button event control
    uint32_t  btn_enable_flag;             //!< button enable flag

} FAPEXFDL_FPC_StrT;


#endif /* !_FAPEX_FDLFPC_PRIV_H */
