/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL IR header file (private)
*/

#ifndef _FAPEX_FDLIR_PRIV_H
#define _FAPEX_FDLIR_PRIV_H

#include "fapi/drv_ir.h"

/*!
*************************************************************************
** \brief FDL IR context structure
*************************************************************************/
typedef struct {
    int32_t     id;         //!< id
    int32_t     used_count; //!< used count
#ifdef __LINUX__
    struct kref kref;           //!< kref struct
    int32_t     close_result;   //!< return code at closing
#endif

    void        *pCfdlHdl;  //!< The pointer to the CFDL context
    int32_t     status;     //!< IR status
    uint32_t    mode;       //!< IR protocol mode (see #FAPEX_IR_MODE_xxx)

    void        *pFAPICtxHdl;           //!< FAPI driver's context

    FAPI_IR_KeycodeMapT *keycode_table; //!< Keycode Map Table data
    uint32_t            keycode_num;    //!< Number of Keycode Map Table

    FAPEXCFDLSAF_EventStrT  dt_event;   //!< data event control

} FAPEXFDL_IR_StrT;

/*! \brief IR event type */
#define FAPEXFDL_IR_EVENT_NONE      (0x0000)    //!< none event
#define FAPEXFDL_IR_EVENT_RECEIVE   (0x0001)    //!< data receive event


#endif /* !_FAPEX_FDLIR_PRIV_H */
