/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL Teletext driver header file (private)
*/

#ifndef _FAPEX_FDLTTX_PRIV_H
#define _FAPEX_FDLTTX_PRIV_H

#include "fapex/abst_libttx.h"

/*!
*************************************************************************
** \brief FDL TTX context structure
*************************************************************************/
typedef struct {
    int32_t id;         //!< id
    int32_t used_count; //!< used count
#ifdef __LINUX__
    struct kref kref;           //!< kref struct
    int32_t     close_result;   //!< return code at closing
#endif

    void    *pCfdlHdl;  //!< The pointer to the CFDL context
    int32_t open_flag;  //!< TTX module open flag
    int32_t status;     //!< TTX status

    void    *pFAPICtxHdl;   //!< FAPI TTX driver's context

} FAPEXFDL_TTX_StrT;

#endif /* !_FAPEX_FDLTTX_PRIV_H */
