/*!
*************************************************************************
**
** \file    fapex_adc_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_ADC_FUNC_H
#define _FAPEX_ADC_FUNC_H

#include "fapi/drv_adc.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
    uint32_t         (*Isr)( void );
    FAPI_SYS_HandleT (*Open)( FAPI_ADC_OpenParamsT* pParams, int32_t* pErrorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    uint32_t        (*Read)( FAPI_SYS_HandleT handle, int32_t *pErrorCode );
    int32_t          (*PowerOff)( void );
    int32_t         (*SetClock)( FAPI_ADC_DividerCountEnumT divider );
} FAPEX_ADC_FuncStrT;

#endif /* _FAPEX_ADC_FUNC_H */
