/*!
*************************************************************************
**
** \file    fapex_board_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
** 
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_BOARD_FUNC_H
#define _FAPEX_BOARD_FUNC_H

#include "fapi/board_ifc.h"

typedef struct {
    void (*SetBoardInitDetectHook)              (FAPI_BOARD_InitDetectHookT      hookPtr);
    void (*SetControlTestLedKeyHook)            (FAPI_BOARD_ControlLedHookT      hookPtr);
    void (*SetControlFeResetHook)               (FAPI_BOARD_ControlFeHookT       hookPt);
    void (*SetControlFeDetectHook)              (FAPI_BOARD_ControlFeDetectHookT hookPtr);
    void (*SetControlHdResetHook)               (FAPI_BOARD_ControlHdHookT       hookPtr);
    void (*SetControlScartHook)                 (FAPI_BOARD_ControlScartHookT    hookPtr);

    void (*SetControlTsPathHook)                (FAPI_BOARD_ControlTsPathHookT   hookPtr);
    void (*SetDiagnostic_TsPath)                (FAPI_BOARD_DiagnosticInfoFlagsT diagIndexAndMasksTsPath,
                                                 FAPI_BOARD_DiagnosticInfoHookT  hookPtr);
    void (*SetDiagnostic_EnableBits_TsPath)     (uint32_t diagSetTsInfoEnaBits);
    void (*SetControlHdmiPathHook)              (FAPI_BOARD_ControlHdmiPathHookT hookPtr);
    void (*SetDiagnostic_HdmiPath)              (FAPI_BOARD_DiagnosticInfoFlagsT diagIndexAndMasksHdmiPath,
                                                 FAPI_BOARD_DiagnosticInfoHookT  hookPtr);
    void (*SetDiagnostic_EnableBits_HdmiPath)   (uint32_t diagSetHdmiInfoEnaBits);
    void (*SetControlUsbPhy)                    (FAPI_BOARD_ControlUsbPhyHookT hookPtr);
    void (*SetControlPowerMode)                 (FAPI_BOARD_ControlSysPwrModeHookT hookPtr);
    void (*SetResourceShare)                    (FAPI_BOARD_ControlResourceHookT hookPtr);
    void (*SetBoardInfo)                        (FAPI_BOARD_HwPlatformInfosT *boardHwInfosPtr);
    FAPI_BOARD_HwPlatformInfosT* (*GetBoardInfo)(void);
    void  (*SetCiInterface)                     (void *ciInterfacePtr);
    void *(*GetCiInterface)                     (void);
    void (*SetDiagnostic_CiInterface)           (FAPI_BOARD_DiagnosticInfoFlagsT diagIndexAndMasksCiCntr,
                                                 FAPI_BOARD_DiagnosticInfoHookT  hookPtr);
    void (*SetDiagnostic_EnableBits_CiInterface)(uint32_t diagSetCiInfoEnaBit);
    void (*SetDiagnostic_GeneralPurpose)        (FAPI_BOARD_DiagnosticInfoFlagsT diagFlagsUser,
                                                 FAPI_BOARD_DiagnosticInfoHookT  hookPtr);
    void (*SetDiagnostic_EnableBits_GeneralPurpose)(uint32_t diagSetUserInfoEnaBit);
   
    void  (*SetExtendedFrontendInfo)            (uint32_t idx,  void *feInfoDataPtr);
    void *(*GetExtendedFrontendInfo)            (uint32_t idx);
    void  (*SetMemoryMapInfo)                   (void *memMapInfoPtr);
    void *(*GetMemoryMapInfo)                   (void);
    void  (*SetOptionalIrData)                  (void *optOtherIrDataPtr);
    void *(*GetOptionalIrData)                  (void );

    void (*SetExtI2cCtrlDrvData)( FAPI_BOARD_ExtI2cDriverDataPtrT *extI2cDrvDataPtr );
    FAPI_BOARD_ExtI2cDriverDataPtrT * (*GetExtI2cCtrlDrvData)( void );

    /* support for FAPI_BOARD_ServicesT */
    FAPI_BOARD_ServicesT BoardServices;
} FAPEX_BOARD_FuncStrT;

#endif /* _FAPEX_BOARD_FUNC_H */
