/*!
*************************************************************************
**
** \file    fapex_boards_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_BOARDS_FUNC_H
#define _FAPEX_BOARDS_FUNC_H

#include "boards/boards_common.h"

typedef struct {
    int32_t (*BoardIfc_Register)             (uint32_t registerFlags, void *optRegisterDataPtr);
    void    (*BoardIfc_SetAddInitHook)       (BOARDS_AddInitHookT addInitCbf);

    int32_t (*RegisterFrontends)             (uint32_t registerFlags, void *optInstallDataPtr);

    int32_t (*RegisterBoardIfc_CstExt)       (uint32_t registerFlags, void *optInstallDataPtr);

    void    (*SetGpioOutpForTestScopeTrigger)(uint32_t  gpio_func);
    void    (*GetTestGpioInput)              (void *optPtr);

    int32_t (*GetTsPinsInputLevel)           (int32_t tsPathIndex, uint16_t *dstTsInpLevelsPtr);

} FAPEX_BOARDS_FuncStrT;

#endif /* _FAPEX_BOARDS_FUNC_H */
