/*!
*************************************************************************
**
** \file    fapex_clkpwr_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_CLKPWR_FUNC_H
#define _FAPEX_CLKPWR_FUNC_H

#include "fapi/drv_clkpwr.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    FAPI_SYS_HandleT (*Open)(const FAPI_CLKPWR_OpenParamsT* paramsPtr,
                                      int32_t* errorCodePtr);
    int32_t          (*Close)(FAPI_SYS_HandleT handle);
    int32_t          (*GetPwm)(FAPI_SYS_HandleT handle, FAPI_CLKPWR_PwmIndexT index, uint32_t *pwmMaximumPtr, uint32_t *pwmSettingPtr);
    int32_t          (*GetState)(FAPI_SYS_HandleT handle);
    int32_t          (*Reset)(FAPI_SYS_HandleT handle, FAPI_CLKPWR_ComponentMaskT componentMask);
    int32_t          (*ResetAudioProcessor)(void);
    void             (*ResetTsdBlock)(uint32_t blockIndex);
    int32_t          (*ResetWatchdog)(FAPI_SYS_HandleT handle);
    int32_t          (*SetPwm)(FAPI_SYS_HandleT handle, uint32_t index, uint32_t pwmMaximum, uint32_t pwmSetting);
    int32_t          (*PowerDown)(FAPI_SYS_HandleT handle, FAPI_CLKPWR_ComponentMaskT componentMask);
    int32_t          (*StartWatchdog)(FAPI_SYS_HandleT handle, uint32_t startValue);
    int32_t          (*StopWatchdog)(FAPI_SYS_HandleT handle);
    int32_t          (*PowerUp)(FAPI_SYS_HandleT handle, FAPI_CLKPWR_ComponentMaskT componentMask);
    void             (*SetPptMode)(uint32_t pptOnOff);
    int32_t          (*SetPllFreq)(uint32_t pllFreq);
    int32_t          (*SetDeepPowerDown)(FAPI_SYS_HandleT handle,
                                                  FAPI_CLKPWR_DeepPowerDownCfgT *cfgPtr);
    int32_t          (*GetWakeupSrc)(FAPI_SYS_HandleT handle,
                                              uint32_t *causePtr);
} FAPEX_CLKPWR_FuncStrT;

#endif /* _FAPEX_CLKPWR_FUNC_H */
