/*!
*************************************************************************
**
** \file    fapex_pv_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/

#ifndef _FAPEX_PV_FUNC_H
#define _FAPEX_PV_FUNC_H

#include "fapi/drv_pv.h"
#include "fapi/drv_pv_ca.h"

typedef struct {
    int32_t          (*Init)( void );
    void              (*Exit)( void );
    FAPI_SYS_HandleT (*Open)( const FAPI_PV_OpenParamsT* paramsPtr, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    int32_t          (*ReadData)( FAPI_SYS_HandleT handle, uint32_t wordIndex, uint32_t bitMask, uint32_t* dataPtr );
    int32_t          (*WriteData)( FAPI_SYS_HandleT handle, uint32_t wordIndex, uint32_t bitMask );
    int32_t          (*GetBurnCounts)( uint32_t* burnCountPtr, uint32_t* burnRetryCountArray );
    void              (*ResetBurnCounts)( void );
    int32_t          (*ReadSipromData)( FAPI_SYS_HandleT handle, uint32_t wordIndex, uint32_t bitMask, uint32_t* dataPtr );
    int32_t          (*ReadSipromBoot)( FAPI_SYS_HandleT handle, uint32_t sectorIndex, uint32_t wordIndex, uint32_t bitMask, uint32_t* dataPtr );
    int32_t          (*WriteSipromData)( FAPI_SYS_HandleT handle, uint32_t wordIndex, uint32_t bitMask );
    int32_t          (*WriteSipromBoot)( FAPI_SYS_HandleT handle, uint32_t sectorIndex, uint32_t wordIndex, uint32_t bitMask );
    int32_t          (*ReadBitfield)( FAPI_SYS_HandleT   handle, FAPI_PV_BitfieldT* bitfieldPtr, uint32_t* dataPtr );
    int32_t          (*WriteBitfield)( FAPI_SYS_HandleT   handle, FAPI_PV_BitfieldT* bitfieldPtr, uint32_t dataValue );
    FAPI_PV_BitfieldT* (*GetBitfieldByName)( char_t* bitfieldStr );
} FAPEX_PV_FuncStrT;

#endif /* _FAPEX_PV_FUNC_H */

