/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 fapi common header file
*/
#ifndef _FAPEX_STD_H
#define _FAPEX_STD_H

#ifdef __LINUX__
#include "fapex_linux_stdhdr.h"

typedef irqreturn_t  FAPICORE_ISRRET_T;
typedef void         FAPICORE_BSRRET_T;
#define FAPICORE_ISRRETVAL(val) {return IRQ_HANDLED;}

#define SA_INTERRUPT IRQF_DISABLED
#else /* __LINUX__ */

#define SA_INTERRUPT (FAPI_SYS_BSR_EXEC_THREAD)
#define SA_SHIRQ     (FAPI_SYS_BSR_EXEC_UNDEFINED)

typedef unsigned long  FAPICORE_ISRRET_T;
typedef void           FAPICORE_BSRRET_T;
#define FAPICORE_ISRRETVAL(val) {return (val);}

#endif /* __LINUX__ */


/* initialize control information */
#define FAPEX_FDL_MODULENUM (25)
#define FAPEX_RAL_MODULENUM (23)

#ifndef FAPICORE_C
extern char FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULENUM];
#endif /* !FAPICORE_C */

#define FAPEX_FDL_MODULEID_AUDEC    (0)
#define FAPEX_FDL_MODULEID_AUOUT    (1)
#define FAPEX_FDL_MODULEID_BM       (2)
#define FAPEX_FDL_MODULEID_DESC     (3)
#define FAPEX_FDL_MODULEID_DMA      (4)
#define FAPEX_FDL_MODULEID_ETH      (5)
#define FAPEX_FDL_MODULEID_FPC      (6)
#define FAPEX_FDL_MODULEID_GPIO     (7)
#define FAPEX_FDL_MODULEID_GPREG    (8)
#define FAPEX_FDL_MODULEID_HDMI     (9)
#define FAPEX_FDL_MODULEID_I2C      (10)
#define FAPEX_FDL_MODULEID_ICC      (11)
#define FAPEX_FDL_MODULEID_INTR     (12)
#define FAPEX_FDL_MODULEID_IR       (13)
#define FAPEX_FDL_MODULEID_MMU      (14)
#define FAPEX_FDL_MODULEID_SSP      (15)
#define FAPEX_FDL_MODULEID_SYNC     (16)
#define FAPEX_FDL_MODULEID_TIMER    (17)
#define FAPEX_FDL_MODULEID_TSD      (18)
#define FAPEX_FDL_MODULEID_UART     (19)
#define FAPEX_FDL_MODULEID_UPI      (20)
#define FAPEX_FDL_MODULEID_USB      (21)
#define FAPEX_FDL_MODULEID_VIDEC    (22)
#define FAPEX_FDL_MODULEID_VIENC    (23)
#define FAPEX_FDL_MODULEID_VISCALE  (24)

#define FAPEX_RAL_MODULEID_AO       (0)
#define FAPEX_RAL_MODULEID_BM       (1)
#define FAPEX_RAL_MODULEID_CLKPWR   (2)
#define FAPEX_RAL_MODULEID_DDRRAMIF (3)
#define FAPEX_RAL_MODULEID_DMA      (4)
#define FAPEX_RAL_MODULEID_ETH      (5)
#define FAPEX_RAL_MODULEID_FPC      (6)
#define FAPEX_RAL_MODULEID_GPIO     (7)
#define FAPEX_RAL_MODULEID_I2C      (8)
#define FAPEX_RAL_MODULEID_ICC      (9)
#define FAPEX_RAL_MODULEID_IR       (10)
#define FAPEX_RAL_MODULEID_IRQ_CTRL (11)
#define FAPEX_RAL_MODULEID_SFLASH   (12)
#define FAPEX_RAL_MODULEID_SSP      (13)
#define FAPEX_RAL_MODULEID_TSD      (14)
#define FAPEX_RAL_MODULEID_UART     (15)
#define FAPEX_RAL_MODULEID_UPI      (16)
#define FAPEX_RAL_MODULEID_VD       (17)
#define FAPEX_RAL_MODULEID_VE       (18)
#define FAPEX_RAL_MODULEID_VE_HD    (19)
#define FAPEX_RAL_MODULEID_VIC      (20)
#define FAPEX_RAL_MODULEID_VO       (21)
#define FAPEX_RAL_MODULEID_ADC      (22)

#endif /* _FAPEX_STD_H */
