/*!
*************************************************************************
**
** \file    fapex_timer_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_TIMER_FUNC_H
#define _FAPEX_TIMER_FUNC_H

#include "fapi/drv_timer.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
#ifndef __LINUX__
    uint32_t         (*Isr0)( void );
#endif /* !__LINUX__ */
    uint32_t         (*Isr1)( void );
    uint32_t         (*Isr2)( void );
#ifndef __LINUX__
    void             (*Bsr0)( uint32_t privData );
#endif /* !__LINUX__ */
    void             (*Bsr1)( uint32_t privData );
    void             (*Bsr2)( uint32_t privData );
    void             (*SetClockFrequency)( uint32_t freqencyHz );
    void             (*SetType)( uint32_t index, uint32_t type );
    void             (*SetResolution)( uint32_t index, uint32_t resolution );
    uint32_t         (*GetIndex)( uint32_t type );
    uint32_t         (*GetResolution)( uint32_t index );
    uint64_t         (*GetTimeStamp)( uint32_t resolution );
    FAPI_SYS_HandleT (*Open)( FAPI_TIMER_OpenParamsT* openParamsPtr, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    int32_t          (*Start)( FAPI_SYS_HandleT handle );
    int32_t          (*Stop)( FAPI_SYS_HandleT handle );
    uint64_t         (*ReadValue)( FAPI_SYS_HandleT handle );
} FAPEX_TIMER_FuncStrT;

#endif /* _FAPEX_TIMER_FUNC_H */
