/*!
*************************************************************************
**
** \file    fapex_ttx_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_TTX_FUNC_H
#define _FAPEX_TTX_FUNC_H

#include "fapi/drv_ttx.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    FAPI_SYS_HandleT (*Open)(const FAPI_TTX_OpenParamsT* paramsPtr,
                             int32_t* errorCodePtr);
    int32_t          (*Close)(FAPI_SYS_HandleT handle);
    void             (*Disable)(void);
    void             (*Enable)(void);
    void             (*EnableReinsertion)(uint32_t enable);
    int32_t          (*SetChannelPid)(FAPI_SYS_HandleT handle, const uint32_t pid);
    int32_t          (*GetChannelPid)(const FAPI_SYS_HandleT handle);
    int32_t          (*GetBufferWritePointerPosition)(const FAPI_SYS_HandleT handle);
    int32_t          (*GetTtxRows)(FAPI_SYS_HandleT handle, uint32_t* ttxRowBuffer, uint32_t removeHeader);
    int32_t          (*Start)(const FAPI_SYS_HandleT handle);
    int32_t          (*Stop)(const FAPI_SYS_HandleT handle);
} FAPEX_TTX_FuncStrT;

#endif /* _FAPEX_TTX_FUNC_H */
