/*!
*************************************************************************
**
** \file    fapex_usb_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_USB_FUNC_H
#define _FAPEX_USB_FUNC_H

#include "fapi/drv_usb.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    uint32_t         (*Isr0)(void);
    void             (*Bsr0)( uint32_t privData );
    void             (*SetBaseAddress)( uint32_t ctrlId,
                                        uint32_t address );
    void             (*SetKeepVbus)( uint32_t keepFlag );
    FAPI_SYS_HandleT (*Open)  ( const FAPI_USB_OpenParamsT* paramsPtr,
                                int32_t* errorCodePtr
                              );
    int32_t          (*Close) ( FAPI_SYS_HandleT handle );
    int32_t          (*RegHostDriver)(
                                FAPI_SYS_HandleT handle,
                                const MUSB_DeviceDriver* driverPtr,
                                const uint8_t* peripheralListPtr,
                                uint32_t listLength);
    int32_t          (*RegFuncDriver)(
                                FAPI_SYS_HandleT handle,
                                const MUSB_FunctionClient* driverPtr );
    int32_t          (*Start)( FAPI_SYS_HandleT handle );
    void             (*Stop)( FAPI_SYS_HandleT handle );
    int32_t          (*Connect)( FAPI_SYS_HandleT handle );
    int32_t          (*Disconnect)( FAPI_SYS_HandleT handle );
    int32_t          (*RelinquishHost)( FAPI_SYS_HandleT handle );
    int32_t          (*RequestBus)( FAPI_SYS_HandleT handle );
    int32_t          (*ResumeBus)( FAPI_SYS_HandleT handle );
    int32_t          (*SuspendBus)( FAPI_SYS_HandleT handle );
    uint32_t         (*IsHost)( FAPI_SYS_HandleT handle );
    uint32_t         (*IsHighSpeed)( FAPI_SYS_HandleT handle );
    uint32_t         (*IsFullSpeed)( FAPI_SYS_HandleT handle );
    uint32_t         (*IsLowSpeed)( FAPI_SYS_HandleT handle );
} FAPEX_USB_FuncStrT;

#endif /* _FAPEX_USB_FUNC_H */
